<!DOCTYPE html>
<html lang="en">
<head>
    
    <meta charset="utf-8">
    <title>Type - Documentation</title>
    
    
    <script src="scripts/prettify/prettify.js"></script>
    <script src="scripts/prettify/lang-css.js"></script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc.css">
    <script src="scripts/nav.js" defer></script>
    
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
</head>
<body>

<input type="checkbox" id="nav-trigger" class="nav-trigger" />
<label for="nav-trigger" class="navicon-button x">
  <div class="navicon"></div>
</label>

<label for="nav-trigger" class="overlay"></label>

<nav >
    
    <input type="text" id="nav-search" placeholder="Search" />
    
    
    <h2><a href="index.html">Home</a></h2><h3>Objects</h3><ul><li><a href="EnumType.html">EnumType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="EnumType.html#getInterpolatedValue">getInterpolatedValue</a></li></ul></li><li><a href="ListType.html">ListType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ListType.html#cost">cost</a></li></ul></li><li><a href="MidiType.html">MidiType</a><ul class='members'></ul></li><li><a href="ModalType.html">ModalType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="ModalType.html#getPi">getPi</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getNu">getNu</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getTau">getTau</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getRho">getRho</a></li><li data-type='method' style='display: none;'><a href="ModalType.html#getOp">getOp</a></li></ul></li><li><a href="NumericType.html">NumericType</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="NumericType.html#getNormalized">getNormalized</a></li></ul></li><li><a href="RecordType.html">RecordType</a><ul class='members'></ul></li><li><a href="SetType.html">SetType</a><ul class='members'></ul></li><li><a href="StringType.html">StringType</a><ul class='members'></ul></li><li><a href="SvgType.html">SvgType</a><ul class='members'></ul></li><li><a href="Type.html">Type</a><ul class='members'></ul><ul class='methods'><li data-type='method' style='display: none;'><a href="Type.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="Type.html#getParameters">getParameters</a></li><li data-type='method' style='display: none;'><a href="Type.html#getValue">getValue</a></li><li data-type='method' style='display: none;'><a href="Type.html#getCheckMessage">getCheckMessage</a></li><li data-type='method' style='display: none;'><a href="Type.html#getDistance">getDistance</a></li><li data-type='method' style='display: none;'><a href="Type.html#getPath">getPath</a></li><li data-type='method' style='display: none;'><a href="Type.html#compare">compare</a></li><li data-type='method' style='display: none;'><a href="Type.html#getBound">getBound</a></li><li data-type='method' style='display: none;'><a href="Type.html#getBounds">getBounds</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getType">getType</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getTypeNames">getTypeNames</a></li><li data-type='method' style='display: none;'><a href="Type.html#.getTypeParameters">getTypeParameters</a></li><li data-type='method' style='display: none;'><a href="Type.html#.addType">addType</a></li></ul></li></ul><h3>Global</h3><ul><li><a href="global.html#json2midi">json2midi</a></li><li><a href="global.html#json2svg">json2svg</a></li><li><a href="global.html#midi2Jon">midi2Jon</a></li><li><a href="global.html#svg2json">svg2json</a></li></ul>
    
</nav>

<div id="main">
    
    <h1 class="page-title">Type</h1>
    

    




<section>

<header>
    
        <h2>
        
            Type
        
        </h2>
        
    
</header>

<article>
    
        <div class="container-overview">
        
            

    

    <h4 class="name" id="Type"><span class="type-signature"></span>new Type<span class="signature">(parameters)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Implements a type on a structured hierarchical value.</p>
<p>See the <a href="./index.html">introduction</a> for a <a href="./symboling.pdf">general presentation</a>.</p>
<p><a name="declaration"></a></p>
<h2>Type declaration</h2>
<ul>
<li>A typical declaration of a type &quot;SomeType&quot; and of name &quot;mytype&quot; with dedicated parameters is given by one of the following two constructs:
<ul>
<li>Here the myType is a static variable in order to be registered during the whole program execution.</li>
</ul>
</li>
</ul>
<pre class="prettyprint source"><code>static symboling::SomeType myType(&quot;{name: myType ...}&quot;);
</code></pre>
<ul>
<li>Here myType is allocated and remains allocated during the whole program execution, and deleted at program shutdown.</li>
</ul>
<pre class="prettyprint source"><code>Type::addType(new SomeType(&quot;{name: myType ...}&quot;));
</code></pre>
<ul>
<li>Predefined parameterized types built on <code>(String|Numeric|Modal|Enum|List|Set|Record)Type</code> can also be defined as data structure, e.g., for a <code>RecordType</code>:</li>
</ul>
<pre class="prettyprint source"><code>Type::addType(&quot;{type: record name: myType ...}&quot;);
</code></pre>
<h2>Predefined standard types</h2>
<ul>
<li>&quot;value&quot;: that matches any predefined value, without any <a href="#specification">further structure</a>.</li>
<li>&quot;modal&quot;: that corresponds to the basic implementation of the <a href="./ModalType.html">ModalType</a>.</li>
<li>&quot;string&quot;: that corresponds to the basic implementation of the <a href="./StringType.html">StringType</a>.</li>
</ul>
<p><a name="derivation"></a></p>
<h2>Implementation of a derived types</h2>
<p>A type defines</p>
<ul>
<li>
<p><a href="#getValue"><code>getValue(value, false)</code></a>: A syntactic projection from any value to a value that can be manipulated in a neighborhood of this type region.</p>
</li>
<li>
<p><a href="#getValue"><code>getValue(value, true)</code></a>: A semantic projection from a syntactically correct value onto a semantically correct value within the state space region.</p>
</li>
<li>
<p><a href="#getCheckMessage"><code>getCheckMessage()</code></a>: A human readable report of what was missing in order the value to be syntactically or semantically correct, during the last <code>getValue()</code> call.</p>
</li>
<li>
<p><a href="#getDistance"><code>getDistance(value_1, value_2)</code></a>: A distance between two semantically correct values.</p>
</li>
<li>
<p><a href="#getPath"><code>getPath(value_1, value_2)</code></a>: A geodesic, i.e. a path of minimal distance, between two semantically correct values.</p>
</li>
<li>
<p><a href="#compare"><code>compare(value_1, value_2)</code></a>: A comparison mechanism between two values of a given type.</p>
</li>
<li>
<p>A typical implementation of a derived  type of name &quot;mytype&quot; is given by the following construct.</p>
<ul>
<li>Here the <code>justDone()</code>, <code>setDistance()</code> and <code>getDistance()</code> constructs allow the implementation to always have the distance well defined before calculating the path.</li>
<li>Here the <code>clearCheckMessage()</code> and <code>addCheckMessage(value, message_a_la_printf, ...)</code>, constructs allow to reset and append a standard error message, optionally with additional parameters using the printf syntax.</li>
</ul>
</li>
</ul>
<pre class="prettyprint source"><code>#include &quot;Type.hpp&quot;
namespace symboling {
  class MyType : public Type {
  public:
    MyType(JSON parameters) : Type(&quot;{name: MyType, parameter: value, ../..}&quot;) {
      ../..
    }
    MyType(String parameters) : MyType(wjson::string2json(parameters)) {}
    MyType(const char *parameters) : Type(wjson::string2json(parameters)) {}

    virtual wjson::Value getValue(JSON value, bool semantically_else_syntactically = true) const {
      startCheckMessage(); // Opens the check message mechanism
      wjson::Value result = value; // Calculates the semantically or syntactically correct value.
      ../..
        addCheckMessage(value, &quot;explanation&quot;, ...); // Adds some human readable message about the required modification if needed, using a à-la printf format
      ../..
      stopCheckMessage(); // Closes the check message mechanism
      return result;
    }

    virtual double getDistance(JSON lhs, JSON rhs) const {
      // Cache mechanism, returns the distance without recalculating it
      if (Type::justDone(lhs, rhs)) return Type::getDistance(lhs, rhs);
      // Otherwise, calculates the distance
      double distance = NAN;
      ../..
      Type::setDistance(lhs, rhs, distance); // Registers the distance for a next call.
      return distance;
    }

    virtual wjson::Value getPath(JSON lhs, JSON rhs) const {
      // Cache mechanism, calculates the distance 1st if not yet done
      if (!Type::justDone(lhs, rhs)) MyType::getDistance(lhs, rhs);
      // Then, calculates the path
      ../..
      return path;
    }

    virtual int compare(JSON lhs, JSON rhs) const {
      // Implements the semi-order comparison between two values
    }

    virtual JSON getBound(unsigned int index) const {
      // Implements the dynamic calculation of the type bound of a given index
      // Alternate solution, using the Type::getBound() without overwritting:
      //  - The protected variable `bounds_count` must be calculated once, at the object construction.
      //  - The protected variable `bounds` allows to store the list of bound values, if not too many.
    }

    virtual String asString() {
      static std::string string;
      string = Type::asString();
      // Adds complementary information related to MyType parameters and state
      ../..
      return string;
    }

  } myType;
  // Allows to register a type from a JSON specification
  static bool MyTypeRegistered = Type::addType(&quot;MyType&quot;, [](JSON parameters) { return new MyType(parameters); });
}
</code></pre>
<p><a name="specification"></a></p>
<h2>ValueType specification</h2>
<table>
<tr style='border: 1px solid black;'><th> Syntactic projection </th><td>
- Returns the value itself, no projection at this level of specification.
</td></tr>
<tr style='border: 1px solid black;'><th> Semantic projection  </th><td>
- Returns the value itself, no projection at this level of specification.
</td></tr>
<tr style='border: 1px solid black;'><th> Distance value       </th><td>
- Returns <tt>NAN</tt> no distance defined at this level of specification.
</td></tr>
<tr style='border: 1px solid black;'><th> Geodesic path        </th><td>
- The geodesic is assumed to be atomic, i.e. of length 1 if value are equal and 2 if different.
</td></tr>
<tr style='border: 1px solid black;'><th> Comparison           </th><td>
- Returns <tt>NAN</tt> no comparison possible at this level of specification.
</td></tr>
<tr style='border: 1px solid black;'><th> Bounds           </th><td>
- The empty value is the unique bound a this level of specification.
</td></tr>
</table></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>parameters</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            

            

            <td class="description last"><p>The type parameters.</p>
<ul>
<li>By contract, the type name is a mandatory parameter, default is &quot;value&quot;.
<ul>
<li>Note: Since each name has a different type it used to define hash, less and equal function to index type in containers, it is possible to define <code>std::unordered_map&lt;symboling::Type, T&gt;</code> or <code>std::map&lt;symboling::Type, T&gt;</code>.</li>
</ul>
</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
        </div>
    

    

    

    
    
    

     

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    <h4 class="name" id="getValue"><span class="type-signature"></span>getValue<span class="signature">(value, semantically_else_syntactically<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {Value}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Parses a string in order to decode its elements as a record item.</p>
<ul>
<li>The input string is parsed as a record, when inputing a string of a suitable format.</li>
<li>The implementation uses the <a href="https://line.gitlabpages.inria.fr/aide-group/aidesys/regex.html#.regexReplace"><code>aidesys::regexReplace()</code></a> method to:
<ul>
<li>Extract values from the input string using capturing parenthesis of the regex.</li>
<li>Substitute the captured value in a wJSON syntax representation of the data structure,
As illustrated by this example:</li>
</ul>
</li>
</ul>
<pre class="prettyprint source"><code>static symboling::RecordType dateStandardFormat(&quot;{&quot;
&quot;name: date &quot;
&quot; parseInput: '([0-9]*)-([0-9]*)-([0-9]*)' &quot;
&quot; parseOutput: '{year: $1 month: $2 day: $3}' }&quot;);
</code></pre>
<p>which corresponds to recommended international standard format for dates.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type">String</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The input value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>semantically_else_syntactically</code></td>
            

            <td class="type">
            
                
<span class="param-type">bool</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>true</code>
                
                </td>
            

            <td class="description last"><ul>
<li>If true projects the value onto a semantically valid value with respect to this type.</li>
<li>If false projects the value onto a syntactically valid value with respect to this type.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The projection of the value onto the a value of this type:</p>
<ul>
<li>If the value is already of this type it is unchanged.</li>
<li>If the value can be mapped on a value of this type, then it is returned.</li>
<li>Otherwise a default &quot;undefined&quot; value or an empty value is returned.</li>
</ul>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Value</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getParameters"><span class="type-signature"></span>getParameters<span class="signature">()</span><span class="type-signature"> &rarr; {JSON}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the type parameters.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The type parameters.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">JSON</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getValue"><span class="type-signature"></span>getValue<span class="signature">(value, semantically_else_syntactically<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {Value}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Projects any value on the closest value of this type.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type">JSON</span>
|

<span class="param-type">String</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The input value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>semantically_else_syntactically</code></td>
            

            <td class="type">
            
                
<span class="param-type">bool</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>true</code>
                
                </td>
            

            <td class="description last"><ul>
<li>If true projects the value onto a semantically valid value with respect to this type.</li>
<li>If false projects the value onto a syntactically valid value with respect to this type.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The projection of the value onto the a value of this type:</p>
<ul>
<li>If the value is already of this type it is unchanged.</li>
<li>If the value can be mapped on a value of this type, then it is returned.</li>
<li>Otherwise a default &quot;undefined&quot; value or an empty value is returned.</li>
</ul>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Value</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getCheckMessage"><span class="type-signature"></span>getCheckMessage<span class="signature">(value<span class="signature-attributes">opt</span>)</span><span class="type-signature"> &rarr; {string}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the getValue call check message.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type">Value</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            

            <td class="description last"><p>If specified returns the getValue call check message for this value, otherwise return the last getValue() evaluation check message.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>A human readable report of what was missing in order the value to be syntactically or semantically correct, during the last getValue call.</p>
<ul>
<li>Empty, i.e. equal to &quot;&quot; if the value fits this type,</li>
<li>Otherwise, a human readable multi-line string with explicit errors of the form:
<ul>
<li><code>// The '$copy-of-the-value' is not of type '$type-name': $explanation</code></li>
</ul>
</li>
</ul>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">string</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getDistance"><span class="type-signature"></span>getDistance<span class="signature">(lhs, rhs)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><h2>Returns the distance between two values of this type.</h2></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>lhs</code></td>
            

            <td class="type">
            
                
<span class="param-type">Value</span>



            
            </td>

            

            

            <td class="description last"><p>The left hand-size value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>rhs</code></td>
            

            <td class="type">
            
                
<span class="param-type">Value</span>



            
            </td>

            

            

            <td class="description last"><p>The right hand-size value.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The positive value of the distance or:</p>
<ul>
<li><tt>0</tt> if the distance itself is undefined, i.e., all values are indistinguishable. This is the default behavior.</li>
<li><tt>DBL_MAX</tt>, for infinity, if values are not comparable or unrelated, thus at infinite distance.</li>
</ul>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getPath"><span class="type-signature"></span>getPath<span class="signature">(lhs, rhs)</span><span class="type-signature"> &rarr; {Array.&lt;string>}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns a geodesic, i.e. a path of minimal distance between two values of this type.</p>
<ul>
<li>By contract, a cache mechanism is to be used, to properly calculates the distance before calculating the path, see the use of<code>justDone()</code>, <code>setDistance()</code> and <code>getDistance()</code>, exemplified above.</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>lhs</code></td>
            

            <td class="type">
            
                
<span class="param-type">Value</span>



            
            </td>

            

            

            <td class="description last"><p>The left hand-size value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>rhs</code></td>
            

            <td class="type">
            
                
<span class="param-type">Value</span>



            
            </td>

            

            

            <td class="description last"><p>The right hand-size value.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The list of intermediate values between left and right hand-size values.</p>
<ul>
<li>If lhs = rhs returns a path of length 1.</li>
<li>If lhs and rhs differs only by an atomic change returns a path of length 2. This is the default behavior.</li>
<li>Usually, several geodesics correspond to the minimal distance and the method is expected to return the ``1st one ´´ in a sense that is to make explicit for each data type.</li>
</ul>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Array.&lt;string></span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="compare"><span class="type-signature"></span>compare<span class="signature">(lhs, rhs)</span><span class="type-signature"> &rarr; {double}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns a semi-order comparison between two values of this type.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>lhs</code></td>
            

            <td class="type">
            
                
<span class="param-type">Value</span>



            
            </td>

            

            

            <td class="description last"><p>The left hand-size value.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>rhs</code></td>
            

            <td class="type">
            
                
<span class="param-type">Value</span>



            
            </td>

            

            

            <td class="description last"><p>The right hand-size value.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The comparison value:</p>
<ul>
<li><code>&lt;0</code> if lhs compares less than rhs.</li>
<li><code>&gt;0</code> if lhs compares more than rhs.</li>
<li><code>0</code> if both value are too close to be comparable.</li>
<li><code>NAN</code> if both value can not be compared, this is the default.</li>
</ul>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">double</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getBound"><span class="type-signature"></span>getBound<span class="signature">(index)</span><span class="type-signature"> &rarr; {Value}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the one value bound for this data type.</p>
<ul>
<li>The <code>uint getBoundsCount()</code> function returns the precise maximal number of bounds for this type.
<ul>
<li>If the bounds count overflows (above 2^64) then it is set to 0, so that no bounds are available.</li>
</ul>
</li>
</ul></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>index</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            

            

            <td class="description last"><p>The bound index.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The bound value or the empty undefined value if out of bound.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Value</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id="getBounds"><span class="type-signature"></span>getBounds<span class="signature">(bounds_count, reset<span class="signature-attributes">opt</span>)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns a list of value bounds for this data type.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>bounds_count</code></td>
            

            <td class="type">
            
                
<span class="param-type">uint</span>



            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>The maximal number of bounds. If <code>bounds_count = 0</code> returns all bounds of the type.</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>reset</code></td>
            

            <td class="type">
            
                
<span class="param-type">bool</span>



            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    <code>false</code>
                
                </td>
            

            <td class="description last"><ul>
<li>If true, redraw the random bound selection.</li>
<li>If false, returns the last bounds calculation result, if with the same bounds_count.</li>
</ul></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>Returns a list of at most bounds_count bounds, randomly selected if <code>bounds_count &lt; getBoundsCount()</code>.</p>
</div>



    



        
            

    

    <h4 class="name" id=".getType"><span class="type-signature type-signature-static">(static) </span>getType<span class="signature">(name)</span><span class="type-signature"> &rarr; {<a href="Type.html">Type</a>}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns a type of the given name.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>name</code></td>
            

            <td class="type">
            
                
<span class="param-type">String</span>



            
            </td>

            

            

            <td class="description last"><p>The type name.</p></td>
        </tr>

    
    </tbody>
</table>
















<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The corresponding type if any, else the generic type of name &quot;value&quot;.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type"><a href="Type.html">Type</a></span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".getTypeNames"><span class="type-signature type-signature-static">(static) </span>getTypeNames<span class="signature">()</span><span class="type-signature"> &rarr; {Value}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the list of all type names.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The list of all type names.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Value</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".getTypeParameters"><span class="type-signature type-signature-static">(static) </span>getTypeParameters<span class="signature">()</span><span class="type-signature"> &rarr; {Value}</span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Returns the list of all type parameters.</p></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>



























<h5 class="h5-returns">Returns:</h5>

        
<div class="param-desc">
    <p>The list of all type parameters.</p>
</div>



<dl class="param-type">
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">Value</span>



    </dd>
</dl>

    



        
            

    

    <h4 class="name" id=".addType"><span class="type-signature type-signature-static">(static) </span>addType<span class="signature">(type)</span><span class="type-signature"></span></h4>

    




<dl class="details">
    
    <dt class="tag-description">Description:</dt>
    <dd class="tag-description"><ul class="dummy"><li><p>Adds a new type from deriving some type with dedicated parameters.
A typical construct is of the form:</p>
<pre class="prettyprint source"><code>Type::addType(new SomeType(&quot;{name: myType ...}&quot;));
</code></pre></li></ul></dd>
    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    

    
</dl>













    <h5 class="h5-parameters">Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>type</code></td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Type.html">Type</a></span>



            
            </td>

            

            

            <td class="description last"><p>The pointer of the type to add.</p>
<ul>
<li>The object is deleted on program shutdown.</li>
<li>The type·s can be defined as
<ul>
<li>A JSON data structure, e.g. of the form <code>{type: record name: myType ...}</code>, including as a string, for type parametrizing  <code>(String|Numeric|Modal|Enum|List|Set|Record)Type</code> etc.</li>
<li>A JSON list of data structures, e.g. of the form <code>[{type: record name: myType ...}</code>, including as a string.</li>
</ul>
</li>
</ul></td>
        </tr>

    
    </tbody>
</table>



















        
    

    

    
</article>

</section>




    
    
</div>

<br class="clear">

<footer>
    <div style='float: right;font-style: italic;'>2025-01-22 version.</div>
</footer>

<script>prettyPrint();</script>
<script src="scripts/polyfill.js"></script>
<script src="scripts/linenumber.js"></script>

<script src="scripts/search.js" defer></script>


<script src="scripts/collapse.js" defer></script>


</body>
</html>